<?php

namespace Eniture\StandardBoxSizes\Controller\Box;

use \Magento\Framework\App\Action\Action;

class AutoRenewPlan extends Action
{

    /**
     * @var object
     */
    private $dataHelper;
    /**
     * @var \Magento\Framework\App\RequestInterface
     */
    private $request;

    /**
     * AutoRenewPlan constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Eniture\StandardBoxSizes\Helper\Data $dataHelper
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Eniture\StandardBoxSizes\Helper\Data $dataHelper
    ) {
        $this->dataHelper   = $dataHelper;
        $this->request      = $context->getRequest();
        parent::__construct($context);
    }
    
    /**
     * Auto renew plan
     */
    function execute()
    {
        $postdata = $this->getRequest()->getPost();
        
        $planAction = isset($postdata['planAction'])?$postdata['planAction']:'';
        $package    = isset($postdata['package'])?$postdata['package']:'';
        $licenseKey = isset($postdata['licenseKey'])?$postdata['licenseKey']:'';
        
        $postArr = [
            'platform'      => 'magento2',
            'request_key'   => md5(microtime() . rand()),
            'action'        => $planAction,
            'package'       => $package,
            'domain_name'   => $this->request->getServer('SERVER_NAME'),
            'license_key'   => $licenseKey,
        ];

        $newPlan = $this->dataHelper->sendRequest($postArr);
        
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode($newPlan));
    }
}
