<?php

namespace Eniture\StandardBoxSizes\Controller\Box;

use \Magento\Framework\App\Action\Action;

class BoxAvailability extends Action
{
    /**
     * @var \Magento\Framework\DB\Adapter\AdapterInterface
     */
    private $connection;
    /**
     * @var string
     */
    private $boxSizesTable;
    /**
     * BoxAvailability constructor.
     * @param \Magento\Framework\App\Action\Context $context
     * @param \Magento\Framework\App\ResourceConnection $resource
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\App\ResourceConnection $resource
    ) {
        $this->connection        = $resource->getConnection(\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION);
        $this->boxSizesTable     = $resource->getTableName('boxsizes');
        parent::__construct($context);
    }

    /**
     * @return \Magento\Framework\App\ResponseInterface|\Magento\Framework\Controller\ResultInterface|void
     */
    function execute()
    {
        $postdata = $this->getRequest()->getPost();
        $available = ($postdata['boxavailable'] == 1)?0:1;
        $boxId = $postdata['box-id'];
        $data = ['boxavailable' => $available];
        
        $updateQry = $this->connection->update("$this->boxSizesTable", $data, "box_id='".$boxId."'");
        if ($updateQry) {
            $result = ['box_id' => $boxId, 'available' => $available];
        }

        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode($result));
    }
}
