<?php

namespace Eniture\StandardBoxSizes\Controller\Box;

use \Magento\Framework\App\Action\Action;

class EditBoxsize extends Action
{
    /**
     * @var object
     */
    private $boxsizesFactory;
    /**
     * EditBoxsize constructor.
     * @param \Eniture\StandardBoxSizes\Model\BoxsizesFactory $boxsizesFactory
     * @param \Magento\Framework\App\Action\Context $context
     */
    public function __construct(
        \Eniture\StandardBoxSizes\Model\BoxsizesFactory $boxsizesFactory,
        \Magento\Framework\App\Action\Context $context
    ) {
        $this->boxsizesFactory = $boxsizesFactory->create();
        parent::__construct($context);
    }
    
    /**
     * Edit Box function
     */
    function execute()
    {
        $postdata = $this->getRequest()->getPost();
        $boxId = htmlspecialchars($postdata['edit-id'], ENT_QUOTES);
        
        $boxList = [];
        $boxCollection = $this->boxsizesFactory->getCollection()->addFilter('box_id', ['eq' => $boxId]);
        
        foreach ($boxCollection as $box) {
            $boxList[] = $box->getData();
        }
        
        $this->getResponse()->setHeader('Content-type', 'application/json');
        $this->getResponse()->setBody(json_encode($boxList));
    }
}
