<?php

namespace Eniture\StandardBoxSizes\Observer;

use Magento\Framework\Event\ObserverInterface;

class OrderPlacebeforeSaveData implements ObserverInterface
{
    /**
     * @var \Magento\Framework\Session\SessionManagerInterface
     */
    private $coreSession;

    /**
     * OrderPlacebeforeSaveData constructor.
     * @param \Magento\Framework\Session\SessionManagerInterface $coreSession
     */
    public function __construct(
        \Magento\Framework\Session\SessionManagerInterface $coreSession
    ) {
        $this->coreSession = $coreSession;
    }

    /**
     * @param \Magento\Framework\Event\Observer $observer
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        try {
            $order = $observer->getEvent()->getOrder();
            $orderBinPackagingData = $this->getBinPackagingData($order);
            $order->setData('bin_packaging', json_encode($orderBinPackagingData));
            $order->save();
        } catch (\Exception $e) {
            error_log($e->getMessage());
        }
    }


    public function getBinPackagingData($order)
    {
        $binPackagingData = $this->coreSession->getSemiBinPackaging();
        $method =  $order->getShippingMethod();

        if ($binPackagingData == NULL) {
            if (strpos($method, 'ENUPSSmpkg') !== false) {
            $binPackagingData = $this->coreSession->getUpsBinPackaging();
            $this->coreSession->unsUpsOrderBinPackaging();
            }
            if (strpos($method, 'ENFedExSmpkg') !== false) {
                $binPackagingData = $this->coreSession->getFdxBinPackaging();
                $this->coreSession->unsFdxBinPackaging();
            }
            if (strpos($method, 'ENWweSmpkg') !== false) {
                $binPackagingData = $this->coreSession->getWweBinPackaging();
                $this->coreSession->unsWweBinPackaging();
            }
            if (strpos($method, 'ENUnishippersSmpkg') !== false) {
                $binPackagingData = $this->coreSession->getUnishippersBinPackaging();
                $this->coreSession->unsUnishippersBinPackaging();
            }
        } else {
            $this->coreSession->unsSemiBinPackaging();
        }
        return $binPackagingData;
    }
}
